/*
 * GToolKit - Objective-C interface to the GIMP Toolkit
 * Copyright (c) 1999  Elmar Ludwig - Universitaet Osnabrueck
 *
 * Generated automatically from gtkcontainer.h by gtkgen.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */
#ifndef GTOOLKIT_GTKCONTAINER_H
#define GTOOLKIT_GTKCONTAINER_H

#include <GToolKit/GTKWidget.h>
#include <gtk/gtkcontainer.h>

@interface GTKContainer : GTKWidget
+ (GtkType) getType;
- (void) setBorderWidth:(guint) border_width;
- (void) add:(GTKWidget *) widget;
- (void) remove:(GTKWidget *) widget;
- (void) setResizeMode:(GtkResizeMode) resize_mode;
- (void) checkResize;
- (void) foreach:(GtkCallback) callback callbackData:(gpointer) callback_data;
- (void) foreachFull:(GtkCallback) callback marshal:(GtkCallbackMarshal) marshal callbackData:(gpointer) callback_data notify:(GtkDestroyNotify) notify;
- (NSArray *) children;
- (gint) focus:(GtkDirectionType) direction;
- (void) setReallocateRedraws:(gboolean) needs_redraws;
- (void) setFocusChild:(GTKWidget *) child;
- (void) setFocusVadjustment:(GTKAdjustment *) adjustment;
- (void) setFocusHadjustment:(GTKAdjustment *) adjustment;
- (void) registerToplevel;
- (void) unregisterToplevel;
+ (NSArray *) getToplevels;
- (void) resizeChildren;
- (GtkType) childType;
+ (void) addChildArgType:(const NSString *) arg_name argType:(GtkType) arg_type argFlags:(guint) arg_flags argId:(guint) arg_id;
+ (GtkArg*) queryChildArgs:(GtkType) class_type argFlags:(guint32 **) arg_flags nArgs:(guint *) nargs;
- (void) childGetv:(GTKWidget *) child nArgs:(guint) n_args args:(GtkArg *) args;
- (void) childSetv:(GTKWidget *) child nArgs:(guint) n_args args:(GtkArg *) args;
- (void) addv:(GTKWidget *) widget nArgs:(guint) n_args args:(GtkArg *) args;
- (void) queueResize;
- (void) clearResizeWidgets;
- (void) argSet:(GTKWidget *) child arg:(GtkArg *) arg info:(GtkArgInfo *) info;
- (void) argGet:(GTKWidget *) child arg:(GtkArg *) arg info:(GtkArgInfo *) info;
+ (NSString *) childArgsCollect:(GtkType) object_type argListP:(GSList **) arg_list_p infoListP:(GSList **) info_list_p firstArgName:(const NSString *) first_arg_name args:(va_list) args;
+ (NSString *) childArgGetInfo:(GtkType) object_type argName:(const NSString *) arg_name infoP:(GtkArgInfo **) info_p;
- (void) forall:(GtkCallback) callback callbackData:(gpointer) callback_data;
- (NSString *) childCompositeName:(GTKWidget *) child;
- (void) dequeueResizeHandler;
@end

#endif
